﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using meIDS_CS;
using System.Diagnostics;



namespace me4660
{
    
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
            stopwatch1.Start();
            io_single = new meIDS.meIOSingle_t[1];

            io_single[0].iDevice = 0;
            io_single[0].iSubdevice = 5; // 5 für DA0 und 6 für DA1
            io_single[0].iChannel = 0;
            io_single[0].iDir = meIDS.ME_DIR_OUTPUT;
            io_single[0].iValue = 0;// Wert 0 bis 65535 (Hex FFFF)
            io_single[0].iTimeOut = 0;// No timeout-not required for software output
            io_single[0].iFlags = meIDS.ME_IO_SINGLE_TYPE_NO_FLAGS;
        }

        meIDS.meIOSingle_t[] io_single;
        int error;
        Stopwatch stopwatch1 = new Stopwatch();
        long dtend = 0, dt = 0, dtavr = 0, cntT0 = 0, dtavr2 = 0;
 
        int device = 0;

        private void butInit_Click(object sender, EventArgs e)
        {
            int error=meIDS.meOpen(0);
            if (error == 0) label5NOK.Text = "OK"; else label5NOK.Text = "NOK";
            if (error == 0)
            {
                device=Convert.ToInt16(comboBox1.Text);
                error = meIDS.meIOSingleConfig(device, 5, 0, 0, meIDS.ME_REF_AO_GROUND, meIDS.ME_TRIG_CHAN_DEFAULT,
                    meIDS.ME_TRIG_TYPE_SW, meIDS.ME_VALUE_NOT_USED, meIDS.ME_IO_SINGLE_CONFIG_NO_FLAGS);
                if (error == 0) label5NOK.Text = "OK"; else label5NOK.Text = "NOK";
                error = meIDS.meIOSingleConfig(device, 6, 0, 0, meIDS.ME_REF_AO_GROUND, meIDS.ME_TRIG_CHAN_DEFAULT,
                    meIDS.ME_TRIG_TYPE_SW, meIDS.ME_VALUE_NOT_USED, meIDS.ME_IO_SINGLE_CONFIG_NO_FLAGS);
                if (error == 0) label5NOK.Text = "OK"; else label5NOK.Text = "NOK";
                timer1.Enabled = true;
                numAO0.Enabled = true;
                numAO1.Enabled = true;

            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Enabled = false;
            meIDS.meClose(0);
        }

        private void numAO0_ValueChanged(object sender, EventArgs e)
        {
            int da0 = (int)numAO0.Value;
            double wert = (da0 + 10) * 65535.0 / 20.0;
            io_single[0].iChannel = 0;
            io_single[0].iDir = meIDS.ME_DIR_OUTPUT; 
            io_single[0].iDevice = device;
            io_single[0].iValue = (int)wert;
            io_single[0].iSubdevice = 5; // 5 für DA0 und 6 für DA1
            error = meIDS.meIOSingle(ref io_single[0], 1, meIDS.ME_IO_SINGLE_NO_FLAGS);
 
        }

        private void numAO1_ValueChanged(object sender, EventArgs e)
        {
            int da0 = (int)numAO1.Value;
            double wert = (da0 + 10) * 65535.0 / 20.0;
            io_single[0].iChannel = 0;
            io_single[0].iDir = meIDS.ME_DIR_OUTPUT; 
            io_single[0].iDevice = device;
            io_single[0].iValue = (int)wert;
            io_single[0].iSubdevice = 6; // 5 für DA0 und 6 für DA1
            error = meIDS.meIOSingle(ref io_single[0], 1, meIDS.ME_IO_SINGLE_NO_FLAGS);
        }

        private void cB2ndChanO_CheckedChanged(object sender, EventArgs e)
        {
            if (cB2ndChanO.Checked)
            {
                label2.Visible = true;
                numAO1.Visible = true;
            } else
            {
                label2.Visible = false;
                numAO1.Visible = false;
            } 
        }

        private void cB2ndChanI_CheckedChanged(object sender, EventArgs e)
        {
            if (cB2ndChanI.Checked)
            {
                label1.Visible = true;
                tBAI1.Visible = true;
            }
            else
            {
                label1.Visible = false;
                tBAI1.Visible = false;
            } 

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //Analog single input          
            long dtstart = stopwatch1.ElapsedTicks;
            io_single[0].iDevice = device;
            io_single[0].iSubdevice = 4; // 5 für DA0 und 6 für DA1, 4 für AD
            io_single[0].iDir = meIDS.ME_DIR_INPUT;
            io_single[0].iChannel = 0; // Kanal 0 bis 15
            error = meIDS.meIOSingle(ref io_single[0], 1, meIDS.ME_IO_SINGLE_NO_FLAGS);
            dtend = stopwatch1.ElapsedTicks;
            long timeAD = dtend - dtstart;
            double outVal=(io_single[0].iValue/65535.0*20.0-10.0);
            tBAI0.Text = outVal.ToString("f3");

            if (cB2ndChanI.Checked)
            {
                dtstart = stopwatch1.ElapsedTicks;
                io_single[0].iChannel = 1;
                error = meIDS.meIOSingle(ref io_single[0], 1, meIDS.ME_IO_SINGLE_NO_FLAGS);
                dtend = stopwatch1.ElapsedTicks;
                timeAD += dtend - dtstart;
                outVal = (io_single[0].iValue / 65535.0 * 20.0 - 10.0);
                tBAI1.Text = outVal.ToString("f3");
                io_single[0].iTimeOut = 0;
            }
            double dtavr1 = timeAD / (double)Stopwatch.Frequency * 1000;
            toolStripStatusLabel1.Text = "DtAD= " + dtavr1.ToString("f3") + " ms";

            //Analog single output          
            int da0 = (int)numAO0.Value;
            double wert = (da0 + 10) * 65535.0 / 20.0;
            dtstart = stopwatch1.ElapsedTicks;
            io_single[0].iChannel = 0;
            io_single[0].iDir = meIDS.ME_DIR_OUTPUT;
            io_single[0].iDevice = device;
            io_single[0].iValue = (int)wert;
            io_single[0].iSubdevice = 5; // 5 für DA0 und 6 für DA1
            error = meIDS.meIOSingle(ref io_single[0], 1, meIDS.ME_IO_SINGLE_NO_FLAGS);
            dtend = stopwatch1.ElapsedTicks;
            long timeDA = dtend - dtstart;
            if (cB2ndChanO.Checked)
            {
                da0 = (int)numAO1.Value;
                wert = (da0 + 10) * 65535.0 / 20.0;
                dtstart = stopwatch1.ElapsedTicks;
                io_single[0].iChannel = 0;
                io_single[0].iDir = meIDS.ME_DIR_OUTPUT;
                io_single[0].iDevice = device;
                io_single[0].iValue = (int)wert;
                io_single[0].iSubdevice = 6; // 5 für DA0 und 6 für DA1
                error = meIDS.meIOSingle(ref io_single[0], 1, meIDS.ME_IO_SINGLE_NO_FLAGS); 
                dtend = stopwatch1.ElapsedTicks;
                timeDA += dtend - dtstart;
            }
            dtavr1 = timeDA / (double)Stopwatch.Frequency * 1000;
            toolStripStatusLabel2.Text = "   DtDA= " + dtavr1.ToString("f3")+" ms";

        }

        private void Form1_Deactivate(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            numAO1.Enabled = false;
            numAO0.Enabled = false;
        }
    }
}
